commit 59ae487e168119e2d2993c24c22dd9f9ebbf774f
Author: Assos Assos <assos+forge@centrale-marseille.fr>
Date:   Thu May 25 00:10:47 2017 +0200

    Weekly update of contrib modules

diff --git a/drupal7/sites/all/modules/entityreference/entityreference.info b/drupal7/sites/all/modules/entityreference/entityreference.info
index 3692ea0f..2695e465 100644
--- a/drupal7/sites/all/modules/entityreference/entityreference.info
+++ b/drupal7/sites/all/modules/entityreference/entityreference.info
@@ -29,9 +29,9 @@ files[] = tests/entityreference.admin.test
 files[] = tests/entityreference.feeds.test
 files[] = tests/entityreference.entity_translation.test
 
-; Information added by Drupal.org packaging script on 2017-05-10
-version = "7.x-1.3"
+; Information added by Drupal.org packaging script on 2017-05-23
+version = "7.x-1.4"
 core = "7.x"
 project = "entityreference"
-datestamp = "1494450489"
+datestamp = "1495557187"
 
diff --git a/drupal7/sites/all/modules/entityreference/entityreference.install b/drupal7/sites/all/modules/entityreference/entityreference.install
index 57f85a6e..ce610185 100644
--- a/drupal7/sites/all/modules/entityreference/entityreference.install
+++ b/drupal7/sites/all/modules/entityreference/entityreference.install
@@ -165,16 +165,24 @@ function entityreference_update_7002() {
 }
 
 /**
+ * Implements hook_update_N().
+ *
  * Remove duplicate rows in the taxonomy_index table.
  */
 function entityreference_update_7100() {
   if (db_table_exists('taxonomy_index')) {
+    if (db_table_exists('taxonomy_index_tmp')) {
+      db_drop_table('taxonomy_index_tmp');
+    }
+
     $tx_schema = drupal_get_schema('taxonomy_index');
     db_create_table('taxonomy_index_tmp', $tx_schema);
     $select = db_select('taxonomy_index', 'tx');
-    $select->fields('tx');
+    $select->fields('tx', array('nid', 'tid'));
     $select->groupBy('tx.nid');
     $select->groupBy('tx.tid');
+    $select->addExpression('MAX(sticky)', 'sticky');
+    $select->addExpression('MAX(created)', 'created');
     db_insert('taxonomy_index_tmp')->from($select)->execute();
     db_drop_table('taxonomy_index');
     db_rename_table('taxonomy_index_tmp', 'taxonomy_index');
diff --git a/drupal7/sites/all/modules/entityreference/examples/entityreference_behavior_example/entityreference_behavior_example.info b/drupal7/sites/all/modules/entityreference/examples/entityreference_behavior_example/entityreference_behavior_example.info
index db5a09e9..6f21bac5 100644
--- a/drupal7/sites/all/modules/entityreference/examples/entityreference_behavior_example/entityreference_behavior_example.info
+++ b/drupal7/sites/all/modules/entityreference/examples/entityreference_behavior_example/entityreference_behavior_example.info
@@ -4,9 +4,9 @@ core = 7.x
 package = Fields
 dependencies[] = entityreference
 
-; Information added by Drupal.org packaging script on 2017-05-10
-version = "7.x-1.3"
+; Information added by Drupal.org packaging script on 2017-05-23
+version = "7.x-1.4"
 core = "7.x"
 project = "entityreference"
-datestamp = "1494450489"
+datestamp = "1495557187"
 
diff --git a/drupal7/sites/all/modules/entityreference/tests/modules/entityreference_feeds_test/entityreference_feeds_test.info b/drupal7/sites/all/modules/entityreference/tests/modules/entityreference_feeds_test/entityreference_feeds_test.info
index 0bcc324b..dace68b7 100644
--- a/drupal7/sites/all/modules/entityreference/tests/modules/entityreference_feeds_test/entityreference_feeds_test.info
+++ b/drupal7/sites/all/modules/entityreference/tests/modules/entityreference_feeds_test/entityreference_feeds_test.info
@@ -8,9 +8,9 @@ dependencies[] = feeds
 dependencies[] = feeds_ui
 dependencies[] = entityreference
 
-; Information added by Drupal.org packaging script on 2017-05-10
-version = "7.x-1.3"
+; Information added by Drupal.org packaging script on 2017-05-23
+version = "7.x-1.4"
 core = "7.x"
 project = "entityreference"
-datestamp = "1494450489"
+datestamp = "1495557187"
 
diff --git a/drupal7/sites/all/modules/file_entity/file_entity.field.inc b/drupal7/sites/all/modules/file_entity/file_entity.field.inc
index 1701c88f..66a5c490 100644
--- a/drupal7/sites/all/modules/file_entity/file_entity.field.inc
+++ b/drupal7/sites/all/modules/file_entity/file_entity.field.inc
@@ -284,45 +284,58 @@ function file_entity_field_formatter_view($entity_type, $entity, $field, $instan
       foreach ($items as $delta => $item) {
         // Protect ourselves from recursive rendering.
         static $recursive_render_depth = array();
-        $recursive_render_id = $entity_type . $field['field_name'] . $item['fid'];
+        if (!empty($item)) {
+          $recursive_render_id = $entity_type . $field['field_name'] . $item['fid'];
+          if (isset($recursive_render_depth[$recursive_render_id])) {
+            $recursive_render_depth[$recursive_render_id]++;
+          }
+          else {
+            $recursive_render_depth[$recursive_render_id] = 1;
+          }
 
-        if (isset($recursive_render_depth[$recursive_render_id])) {
-          $recursive_render_depth[$recursive_render_id]++;
-        }
-        else {
-          $recursive_render_depth[$recursive_render_id] = 1;
-        }
+          if ($recursive_render_depth[$recursive_render_id] > 20) {
+            watchdog(
+              'file_entity',
+              'Recursive rendering detected when rendering entity %entity_type: %entity_id, using the %field_name field. Aborting rendering.',
+              array(
+                '%entity_type' => 'file',
+                '%entity_id' => $item['fid'],
+                '%field_name' => $field['field_name'],
+              ),
+              WATCHDOG_ERROR
+            );
+            return $element;
+          }
+
+          $file = file_load($item['fid']);
+
+          // Add some references to the referencing entity.
+          // @see https://www.drupal.org/node/2333107
+          $file->referencing_entity = $entity;
+          $file->referencing_entity_type = $entity_type;
+          $file->referencing_field = $field['field_name'];
 
-        if ($recursive_render_depth[$recursive_render_id] > 20) {
+          $element[$delta] = file_view($file, $settings['file_view_mode'], $langcode);
+        } else {
           watchdog(
             'file_entity',
-            'Recursive rendering detected when rendering entity %entity_type: %entity_id, using the %field_name field. Aborting rendering.',
+            'In the %referencing_entity_type, the %field_name field refers to a %entity_type which does not exist. Aborting the render for it.',
             array(
-              '%entity_type' => 'file',
-              '%entity_id' => $item['fid'],
+              '%referencing_entity_type' => $entity_type,
               '%field_name' => $field['field_name'],
+              '%entity_type' => 'file',
             ),
             WATCHDOG_ERROR
           );
-          return $element;
         }
-
-        $file = (object) $item;
-
-        // Add some references to the referencing entity.
-        // @see https://www.drupal.org/node/2333107
-        $file->referencing_entity = $entity;
-        $file->referencing_entity_type = $entity_type;
-        $file->referencing_field = $field['field_name'];
-
-        $element[$delta] = file_view($file, $settings['file_view_mode'], $langcode);
       }
       break;
 
     case 'file_download_link':
+      // Prevent 'empty' fields from causing a WSOD.
+      $items = array_filter($items);
       foreach ($items as $delta => $item) {
-        $file = (object) $item;
-        if (file_entity_access('download', $file)) {
+        if (!empty($item['fid']) && ($file = file_load($item['fid'])) && file_entity_access('download', $file)) {
           $element[$delta] = array(
             '#theme' => 'file_entity_download_link',
             '#file' => $file,
@@ -342,14 +355,14 @@ function file_entity_field_formatter_view($entity_type, $entity, $field, $instan
       $source_lists = array();
       if ($multiple_file_behavior == 'tags') {
         foreach ($items as $delta => $item) {
-          if ($item['type'] == 'audio') {
+          if (file_entity_file_get_mimetype_type($item) == 'audio') {
             $source_lists[$delta] = array($item);
           }
         }
       }
       else {
         foreach ($items as $delta => $item) {
-          if ($item['type'] == 'audio') {
+          if (file_entity_file_get_mimetype_type($item) == 'audio') {
             $source_lists[0][$delta] = $item;
           }
         }
@@ -378,14 +391,14 @@ function file_entity_field_formatter_view($entity_type, $entity, $field, $instan
       $source_lists = array();
       if ($multiple_file_behavior == 'tags') {
         foreach ($items as $delta => $item) {
-          if ($item['type'] == 'video') {
+          if (file_entity_file_get_mimetype_type($item) == 'video') {
             $source_lists[$delta] = array($item);
           }
         }
       }
       else {
         foreach ($items as $delta => $item) {
-          if ($item['type'] == 'video') {
+          if (file_entity_file_get_mimetype_type($item) == 'video') {
             $source_lists[0][$delta] = $item;
           }
         }
diff --git a/drupal7/sites/all/modules/file_entity/file_entity.info b/drupal7/sites/all/modules/file_entity/file_entity.info
index 03afc179..5476c7f1 100644
--- a/drupal7/sites/all/modules/file_entity/file_entity.info
+++ b/drupal7/sites/all/modules/file_entity/file_entity.info
@@ -9,6 +9,7 @@ dependencies[] = ctools
 dependencies[] = system (>=7.33)
 
 test_dependencies[] = token
+test_dependencies[] = views
 
 files[] = views/views_handler_argument_file_type.inc
 files[] = views/views_handler_field_file_rendered.inc
@@ -24,15 +25,16 @@ files[] = views/views_handler_field_file_link_usage.inc
 files[] = views/views_plugin_row_file_rss.inc
 files[] = views/views_plugin_row_file_view.inc
 files[] = file_entity.test
+files[] = file_entity_views.test
 
 configure = admin/config/media/file-settings
 
 ; We have to add a fake version so Git checkouts do not fail Media dependencies
 version = 7.x-2.x-dev
 
-; Information added by Drupal.org packaging script on 2016-05-31
-version = "7.x-2.0-beta3"
+; Information added by Drupal.org packaging script on 2017-05-22
+version = "7.x-2.0"
 core = "7.x"
 project = "file_entity"
-datestamp = "1464653173"
+datestamp = "1495456387"
 
diff --git a/drupal7/sites/all/modules/file_entity/file_entity.module b/drupal7/sites/all/modules/file_entity/file_entity.module
index 36f82830..bbd4d2f1 100644
--- a/drupal7/sites/all/modules/file_entity/file_entity.module
+++ b/drupal7/sites/all/modules/file_entity/file_entity.module
@@ -1794,7 +1794,7 @@ function file_entity_query_file_access_alter(QueryAlterableInterface $query) {
  * access conditions are added for field values belonging to files only.
  */
 function file_entity_query_entity_field_access_alter(QueryAlterableInterface $query) {
-  //_file_entity_query_file_entity_access_alter($query, 'entity');
+  _file_entity_query_file_entity_access_alter($query, 'entity');
 }
 
 /**
@@ -1822,6 +1822,12 @@ function _file_entity_query_file_entity_access_alter($query, $type) {
 
   $tables = $query->getTables();
   $base_table = $query->getMetaData('base_table');
+  // Do not use the base table for general entity queries unless this is
+  // querying the file_managed table directly.
+  if ($base_table && $type == 'entity' && $base_table != 'file_managed') {
+    $base_table = '';
+  }
+
   // If no base table is specified explicitly, search for one.
   if (!$base_table) {
     $fallback = '';
@@ -1853,6 +1859,10 @@ function _file_entity_query_file_entity_access_alter($query, $type) {
               $fallback = $table;
             }
           }
+          elseif (isset($schema['fields']['entity_id']) && isset($schema['fields']['entity_type']) && isset($schema['fields']['deleted']) && isset($schema['fields']['delta'])) {
+            // The table is a field data table, use it as fallback.
+            $base_table = $table;
+          }
         }
       }
     }
@@ -1863,6 +1873,11 @@ function _file_entity_query_file_entity_access_alter($query, $type) {
         $base_table = $fallback;
       }
       else {
+        // Ignore this query as it was a general field query and no
+        // relationships were found to the file_managed table.
+        if ($type == 'entity') {
+          return;
+        }
         throw new Exception(t('Query tagged for file access but there is no fid. Add foreign keys to file_managed.fid in schema to fix.'));
       }
     }
@@ -1925,33 +1940,36 @@ function _file_entity_query_file_entity_access_alter($query, $type) {
         }
       }
 
-      if ($subquery_conditions->count()) {
+      // If there is no subquery conditions, the query is likely for file usage.
+      // Or user can only access public files.
+      // If there are subquery conditions then add them to the subquery.
+      if ($subquery_conditions->count() >= 1) {
         $subquery->condition($subquery_conditions);
+      }
 
-        $field = 'fid';
-        // Now handle entities.
-        if ($type == 'entity') {
-          // Set a common alias for entities.
-          $base_alias = $falias;
-          $field = 'entity_id';
-        }
-        $subquery->where("$falias.$field = fm_access.fid");
+      $field = 'fid';
+      // Now handle entities.
+      if ($type == 'entity') {
+        // Set a common alias for entities.
+        $base_alias = $falias;
+        $field = ($falias == 'file_managed' ? 'fid' : 'entity_id');
+      }
+      $subquery->where("$falias.$field = fm_access.fid");
 
-        // For an entity query, attach the subquery to entity conditions.
-        if ($type == 'entity') {
-          $file_conditions->exists($subquery);
-        }
-        // Otherwise attach it to the node query itself.
-        elseif ($table == 'file_managed') {
-          // Fix for https://drupal.org/node/2073085
-          $db_or = db_or();
-          $db_or->exists($subquery);
-          $db_or->isNull($falias . '.' . $field);
-          $query->condition($db_or);
-        }
-        else {
-          $query->exists($subquery);
-        }
+      // For an entity query, attach the subquery to entity conditions.
+      if ($type == 'entity') {
+        $file_conditions->exists($subquery);
+      }
+      // Otherwise attach it to the node query itself.
+      elseif ($table == 'file_managed') {
+        // Fix for https://drupal.org/node/2073085
+        $db_or = db_or();
+        $db_or->exists($subquery);
+        $db_or->isNull($falias . '.' . $field);
+        $query->condition($db_or);
+      }
+      else {
+        $query->exists($subquery);
       }
     }
   }
@@ -1959,14 +1977,19 @@ function _file_entity_query_file_entity_access_alter($query, $type) {
   if ($type == 'entity' && $file_conditions->count()) {
     // All the file access conditions are only for field values belonging to
     // files.
-    $file_conditions->condition("$base_alias.entity_type", 'file');
-    $or = db_or();
-    $or->condition($file_conditions);
-    // If the field value belongs to a non-file entity type then this function
-    // does not do anything with it.
-    $or->condition("$base_alias.entity_type", 'file', '<>');
-    // Add the compiled set of rules to the query.
-    $query->condition($or);
+    if ($base_alias !== 'file_managed') {
+      $file_conditions->condition("$base_alias.entity_type", 'file');
+      $or = db_or();
+      $or->condition($file_conditions);
+      // If the field value belongs to a non-file entity type then this function
+      // does not do anything with it.
+      $or->condition("$base_alias.entity_type", 'file', '<>');
+      // Add the compiled set of rules to the query.
+      $query->condition($or);
+    }
+    else {
+      $query->condition($file_conditions);
+    }
   }
 }
 
@@ -2479,6 +2502,9 @@ function file_entity_download_uri($file) {
 }
 
 function file_entity_file_get_mimetype_type($file) {
+  if (is_array($file)) {
+    $file = (object) $file;
+  }
   list($type, $subtype) = explode('/', $file->filemime, 2);
   return $type;
 }
@@ -2600,3 +2626,4 @@ function file_entity_features_pipe_file_type_alter(&$pipe, $data, $export) {
     $pipe['variable'][] = "pathauto_file_{$file_type}_pattern";
   }
 }
+
diff --git a/drupal7/sites/all/modules/file_entity/file_entity.pages.inc b/drupal7/sites/all/modules/file_entity/file_entity.pages.inc
index 9d6e359b..e10cfe61 100644
--- a/drupal7/sites/all/modules/file_entity/file_entity.pages.inc
+++ b/drupal7/sites/all/modules/file_entity/file_entity.pages.inc
@@ -35,10 +35,12 @@ function file_entity_download_page($file) {
   if (!is_file($file->uri)) {
     return MENU_NOT_FOUND;
   }
-
+  // @todo Remove this once drupal_basename is fixed for PHP versions greater
+  //  than '5.3.29'.
+  $basename_function = version_compare(PHP_VERSION,'5.3.29','>') ? 'basename' : 'drupal_basename';
   $headers = array(
     'Content-Type' => mime_header_encode($file->filemime),
-    'Content-Disposition' => 'attachment; filename="' . mime_header_encode(drupal_basename($file->uri)) . '"',
+    'Content-Disposition' => 'attachment; filename="' . mime_header_encode($basename_function($file->uri)) . '"',
     'Content-Length' => $file->filesize,
     'Content-Transfer-Encoding' => 'binary',
     'Pragma' => 'no-cache',
@@ -77,7 +79,10 @@ function file_entity_download_page($file) {
  * - Edit fields
  *   Skip this step if there are no fields on this entity type.
  */
-function file_entity_add_upload($form, &$form_state, array $options = array()) {
+function file_entity_add_upload($form, &$form_state, $options = array()) {
+  if (!is_array($options)) {
+    $options = array($options);
+  }
   $step = (isset($form_state['step']) && in_array($form_state['step'], array(1, 2, 3, 4))) ? $form_state['step'] : 1;
   $form['#step'] = $step;
   $form['#options'] = $options;
@@ -398,6 +403,7 @@ function file_entity_add_upload_submit($form, &$form_state) {
   // We have the filetype, check if we can skip step 4.
   if (($form['#step'] == 3 && $trigger == 'edit-next')) {
     $file = file_load($form_state['storage']['upload']);
+    $form_state['file'] = $file;
     if (!field_info_instances('file', $form_state['storage']['type'])) {
       // This filetype doesn't have fields, save the file.
       $save = TRUE;
@@ -800,21 +806,25 @@ function file_entity_edit_submit($form, &$form_state) {
   if (!empty($form_state['values']['replace_upload'])) {
     $replacement = $form_state['values']['replace_upload'];
     // Move file from temp to permanent home.
-    $destination_uri = rtrim($file->uri, drupal_basename($file->uri)) . drupal_basename($replacement->uri);
-    $replace_mode = $destination_uri == $file->uri ? FILE_EXISTS_REPLACE : FILE_EXISTS_RENAME;
-    if ($new_file_uri = file_unmanaged_copy($replacement->uri, $destination_uri, $replace_mode)) {
-      // @todo Add watchdog() about replaced file here?
-
-      // Remove temporary file.
-      file_delete($replacement);
-
-      // Update if the uri target has changed.
-      if ($new_file_uri != $file->uri) {
-       // Store the original file uri to delete if save is successful.
-       $orphaned_uri = $file->uri;
-
-        // Update file entity uri.
-        $file->uri = $new_file_uri;
+    if (pathinfo($replacement->uri, PATHINFO_EXTENSION) == pathinfo($file->uri, PATHINFO_EXTENSION)) {
+        file_unmanaged_copy($replacement->uri, $file->uri, FILE_EXISTS_REPLACE);
+    } else {
+      $destination_uri = rtrim($file->uri, drupal_basename($file->uri)) . drupal_basename($replacement->uri);
+      $replace_mode = $destination_uri == $file->uri ? FILE_EXISTS_REPLACE : FILE_EXISTS_RENAME;
+      if ($new_file_uri = file_unmanaged_copy($replacement->uri, $destination_uri, $replace_mode)) {
+        // @todo Add watchdog() about replaced file here?
+
+        // Remove temporary file.
+        file_delete($replacement);
+
+        // Update if the uri target has changed.
+        if ($new_file_uri != $file->uri) {
+         // Store the original file uri to delete if save is successful.
+         $orphaned_uri = $file->uri;
+
+          // Update file entity uri.
+          $file->uri = $new_file_uri;
+        }
       }
     }
   }
diff --git a/drupal7/sites/all/modules/file_entity/file_entity.pathauto.inc b/drupal7/sites/all/modules/file_entity/file_entity.pathauto.inc
index 3b3d6957..98befe3a 100644
--- a/drupal7/sites/all/modules/file_entity/file_entity.pathauto.inc
+++ b/drupal7/sites/all/modules/file_entity/file_entity.pathauto.inc
@@ -27,7 +27,7 @@ function file_entity_pathauto($op) {
       $settings['token_type'] = 'file';
       $settings['groupheader'] = t('File paths');
       $settings['patterndescr'] = t('Default path pattern (applies to all file types with blank patterns below)');
-      $settings['patterndefault'] = 'files/[file:name]';
+      $settings['patterndefault'] = '';
       $settings['batch_update_callback'] = 'file_entity_pathauto_bulk_update_batch_process';
       $settings['batch_file'] = drupal_get_path('module', 'file_entity') . '/file_entity.pathauto.inc';
 
diff --git a/drupal7/sites/all/modules/file_entity/file_entity.test b/drupal7/sites/all/modules/file_entity/file_entity.test
index 20f47cab..96a45102 100644
--- a/drupal7/sites/all/modules/file_entity/file_entity.test
+++ b/drupal7/sites/all/modules/file_entity/file_entity.test
@@ -1205,7 +1205,7 @@ class FileEntityTypeTestCase extends FileEntityTestHelper {
     $this->drupalGet('admin/structure/file-types');
     $this->assertResponse(403, 'File types UI page is not accessible to unauthorized users.');
 
-    $user = $this->drupalCreateUser(array('administer file types'));
+    $user = $this->drupalCreateUser(array('administer file types', 'administer fields'));
     $this->drupalLogin($user);
 
     $this->drupalGet('admin/structure/file-types');
@@ -1671,4 +1671,132 @@ class FileEntityAttributeOverrideTestCase extends FileEntityTestHelper {
       $this->assertEqual($build['#file']->$attribute, $expected_value, format_string('The %attribute was overridden correctly.', array('%attribute' => $attribute)));
     }
   }
+
+  /**
+   * @param EntityFieldQuery $query
+   * @param $expected
+   *   An associative array of expected result. Keys are file ids, values are
+   *   booleans to indicate if the result should include the file.
+   */
+  function assertEntityFieldQueryAccess(EntityFieldQuery $query, $expected, $account = NULL, $query_name = 'unnamed') {
+    if ($account) {
+      $query->addMetaData('account', $account);
+    }
+    $query->addTag('entity_field_access');
+    $results = $query->execute();
+    $fids = isset($results['file']) ? array_keys($results['file']) : array();
+    foreach ($expected as $fid => $in_result) {
+      if ($in_result) {
+        $this->assertTrue(in_array($fid, $fids), format_string("For the %name query, the result should contain %fid", array('%name' => $query_name, '%fid' => $fid)));
+      }
+      else {
+        $this->assertFalse(in_array($fid, $fids), format_string("For the %name query, the result should not contain %fid", array('%name' => $query_name, '%fid' => $fid)));
+      }
+    }
+  }
+
+  /**
+   * Test file entity access for entity field queries.
+   */
+  function testEntityFieldQueryAccess() {
+    // Attach a text field to the default image file type.
+    $field = array(
+      'field_name' => drupal_strtolower($this->randomName()),
+      'type' => 'text',
+      'settings' => array(
+        'max_length' => 255,
+      )
+    );
+    field_create_field($field);
+    $instance = array(
+      'field_name' => $field['field_name'],
+      'entity_type' => 'file',
+      'bundle' => 'document',
+      'widget' => array(
+        'type' => 'text_textfield',
+      ),
+      'display' => array(
+        'default' => array(
+          'type' => 'text_default',
+        ),
+      ),
+    );
+    field_create_instance($instance);
+    // Create test files.
+    $file_owner = $this->drupalCreateUser(array('view own files', 'view own private files'));
+    $public_file = $this->createFileEntity(array(
+      'status' => 0,
+    ));
+    $private_file = $this->createFileEntity(array('scheme' => 'private'));
+    $owned_public_file = $this->createFileEntity(array(
+      'uid' => $file_owner->uid,
+      'scheme' => 'public',
+    ));
+    $owned_private_file = $this->createFileEntity(array(
+      'uid' => $file_owner->uid,
+      'scheme' => 'private',
+    ));
+    $fids = array(
+      $public_file->fid,
+      $private_file->fid,
+      $owned_public_file->fid,
+      $owned_private_file->fid,
+    );
+    foreach (file_load_multiple($fids) as $file) {
+      $file->{$field['field_name']}[LANGUAGE_NONE][0] = array('value' => 'find me');
+      file_save($file);
+    }
+
+    $efq_fids = new EntityFieldQuery();
+    $queries['entity type and id conditions'] = $efq_fids
+      ->entityCondition('entity_type', 'file')
+      ->entityCondition('entity_id', $fids);
+    $efq_field_name = new EntityFieldQuery();
+    $queries['single field condition'] = $efq_field_name
+      ->fieldCondition($field['field_name'], 'value', 'find me');
+
+    foreach($queries as $name => $query) {
+      $message = format_string('');
+      // User should not see private files, only his own public files.
+      $this->assertEntityFieldQueryAccess(clone $query, array(
+        $public_file->fid => TRUE,
+        $private_file->fid => FALSE,
+        $owned_public_file->fid => TRUE,
+        $owned_private_file->fid => FALSE,
+      ), $this->drupalCreateUser(array('create files')), $name);
+
+      // A user with the 'view own files' and 'view own private files' permissions should only see owned files and public files.
+      $this->drupalLogin($file_owner);
+      $this->assertEntityFieldQueryAccess(clone $query, array(
+        $public_file->fid => TRUE,
+        $private_file->fid => FALSE,
+        $owned_public_file->fid => TRUE,
+        $owned_private_file->fid => TRUE,
+      ), $file_owner, $name);
+
+      // User with the 'view files' permission should only see public files but cannot create files.
+      $this->assertEntityFieldQueryAccess(clone $query, array(
+        $public_file->fid => TRUE,
+        $private_file->fid => FALSE,
+        $owned_public_file->fid => TRUE,
+        $owned_private_file->fid => FALSE,
+      ), $this->drupalCreateUser(array('view files')), $name);
+
+      // User with the 'view files' and 'view private files' permissions should only see all files.
+      $this->assertEntityFieldQueryAccess(clone $query, array(
+        $public_file->fid => TRUE,
+        $private_file->fid => TRUE,
+        $owned_public_file->fid => TRUE,
+        $owned_private_file->fid => TRUE,
+      ), $this->drupalCreateUser(array('view files', 'view private files')), $name);
+
+      // User with the 'bypass file access' permissions should only see all files.
+      $this->assertEntityFieldQueryAccess(clone $query, array(
+        $public_file->fid => TRUE,
+        $private_file->fid => TRUE,
+        $owned_public_file->fid => TRUE,
+        $owned_private_file->fid => TRUE,
+      ), $this->drupalCreateUser(array('bypass file access')), $name);
+    }
+  }
 }
diff --git a/drupal7/sites/all/modules/file_entity/file_entity.theme.inc b/drupal7/sites/all/modules/file_entity/file_entity.theme.inc
index c05d3320..aa78d5d2 100644
--- a/drupal7/sites/all/modules/file_entity/file_entity.theme.inc
+++ b/drupal7/sites/all/modules/file_entity/file_entity.theme.inc
@@ -12,18 +12,37 @@
  */
 function theme_file_entity_file_link($variables) {
   $file = $variables['file'];
-  $icon_directory = $variables['icon_directory'];
+  $uri = entity_uri('file', $file);
+
+  // Human-readable names, for use as text-alternatives to icons.
+  $mime_name = array(
+    'application/msword' => t('Microsoft Office document icon'),
+    'application/vnd.ms-excel' => t('Office spreadsheet icon'),
+    'application/vnd.ms-powerpoint' => t('Office presentation icon'),
+    'application/pdf' => t('PDF icon'),
+    'video/quicktime' => t('Movie icon'),
+    'audio/mpeg' => t('Audio icon'),
+    'audio/wav' => t('Audio icon'),
+    'image/jpeg' => t('Image icon'),
+    'image/png' => t('Image icon'),
+    'image/gif' => t('Image icon'),
+    'application/zip' => t('Package icon'),
+    'text/html' => t('HTML icon'),
+    'text/plain' => t('Plain text icon'),
+    'application/octet-stream' => t('Binary Data'),
+  );
+
+  $mimetype = file_get_mimetype($file->uri);
 
-  $url = 'file/' . $file->fid;
-  $icon = theme('file_icon', array('file' => $file, 'icon_directory' => $icon_directory));
+  $icon = theme('file_icon', array(
+    'file' => $file,
+    'icon_directory' => $variables['icon_directory'],
+    'alt' => !empty($mime_name[$mimetype]) ? $mime_name[$mimetype] : t('File'),
+  ));
 
   // Set options as per anchor format described at
   // http://microformats.org/wiki/file-format-examples
-  $options = array(
-    'attributes' => array(
-      'type' => $file->filemime . '; length=' . $file->filesize,
-    ),
-  );
+  $uri['options']['attributes']['type'] = $file->filemime . '; length=' . $file->filesize;
 
   // Use the description as the link text if available.
   if (empty($file->description)) {
@@ -44,10 +63,33 @@ function theme_file_entity_file_link($variables) {
  */
 function theme_file_entity_download_link($variables) {
   $file = $variables['file'];
-  $icon_directory = $variables['icon_directory'];
-
   $uri = file_entity_download_uri($file);
-  $icon = theme('file_icon', array('file' => $file, 'icon_directory' => $icon_directory));
+
+  // Human-readable names, for use as text-alternatives to icons.
+  $mime_name = array(
+    'application/msword' => t('Microsoft Office document icon'),
+    'application/vnd.ms-excel' => t('Office spreadsheet icon'),
+    'application/vnd.ms-powerpoint' => t('Office presentation icon'),
+    'application/pdf' => t('PDF icon'),
+    'video/quicktime' => t('Movie icon'),
+    'audio/mpeg' => t('Audio icon'),
+    'audio/wav' => t('Audio icon'),
+    'image/jpeg' => t('Image icon'),
+    'image/png' => t('Image icon'),
+    'image/gif' => t('Image icon'),
+    'application/zip' => t('Package icon'),
+    'text/html' => t('HTML icon'),
+    'text/plain' => t('Plain text icon'),
+    'application/octet-stream' => t('Binary Data'),
+  );
+
+  $mimetype = file_get_mimetype($file->uri);
+
+  $icon = theme('file_icon', array(
+    'file' => $file,
+    'icon_directory' => $variables['icon_directory'],
+    'alt' => !empty($mime_name[$mimetype]) ? $mime_name[$mimetype] : t('File'),
+  ));
 
   // Set options as per anchor format described at
   // http://microformats.org/wiki/file-format-examples
